

var LBG_window_titlebarheight (LBG_WINDOW* win)
{
	if(win->flags & WFi_NOTITLEBAR) return 0;
	else return bmap_height(win->bbmaps.bmap_titlebar_left);
}

var LBG_window_leftborderwidth (LBG_WINDOW* win)
{
	if(win->flags & WFi_NOBORDER) return 0;
	else return bmap_width(win->bbmaps.bmap_border_left);
}

var LBG_window_rightborderwidth (LBG_WINDOW* win)
{
	if(win->flags & WFi_NOBORDER) return 0;
	else return bmap_width(win->bbmaps.bmap_border_right);
}

var LBG_window_bottomborderheight (LBG_WINDOW* win)
{
	if(win->flags & WFi_NOBORDER) return 0;
	else return bmap_height(win->bbmaps.bmap_border_bottom);
}

var LBG_window_num_titiblebar_buttons (LBG_WINDOW* win)
{
	var ret = 0;
	if (win->flags & WF_XBUTTON) ret++;
	if (win->flags & WF_MAXBUTTON) ret++;
	return(ret);
}

void LBG_window_border_bitmap (BMAP* _bmap, LBG_WBORDER_BMAPS* bmaps, var size_x, var size_y) // For internal use
{
	bmap_blit(_bmap,bmaps->bmap_titlebar_left,vector(0,0,0),NULL);
	bmap_blit(_bmap,bmaps->bmap_titlebar_right,vector(size_x-bmap_width(bmaps->bmap_titlebar_right),0,0),NULL);
	bmap_blit(_bmap,bmaps->bmap_titlebar_middle,vector(bmap_width(bmaps->bmap_titlebar_left),0,0),vector(size_x-bmap_width(bmaps->bmap_titlebar_left)-bmap_width(bmaps->bmap_titlebar_right),bmap_height(bmaps->bmap_titlebar_middle),0));
	
	if(!bmaps->bmap_border_bottomleft) return;
	bmap_blit(_bmap,bmaps->bmap_border_bottomleft,vector(0,size_y-bmap_height(bmaps->bmap_border_bottomleft),0),NULL);
	bmap_blit(_bmap,bmaps->bmap_border_bottomright,vector(size_x-bmap_width(bmaps->bmap_border_bottomright),size_y-bmap_height(bmaps->bmap_border_bottomright),0),NULL);
	bmap_blit(_bmap,bmaps->bmap_border_left,vector(0,bmap_height(bmaps->bmap_titlebar_middle),0),vector(bmap_width(bmaps->bmap_border_left),size_y-bmap_height(bmaps->bmap_titlebar_middle)-bmap_height(bmaps->bmap_border_bottomleft),0));
	bmap_blit(_bmap,bmaps->bmap_border_right,vector(size_x-bmap_width(bmaps->bmap_border_right),bmap_height(bmaps->bmap_titlebar_middle),0),vector(bmap_width(bmaps->bmap_border_right),size_y-bmap_height(bmaps->bmap_titlebar_middle)-bmap_height(bmaps->bmap_border_bottomright),0));
	bmap_blit(_bmap,bmaps->bmap_border_bottom,vector(bmap_width(bmaps->bmap_border_bottomleft),size_y-bmap_height(bmaps->bmap_border_bottom),0),vector(size_x-bmap_width(bmaps->bmap_border_left)-bmap_width(bmaps->bmap_border_right),bmap_height(bmaps->bmap_border_bottom),0));
}

void LBG_window_content_bitmap (BMAP* _bmap, LBG_CBORDER_BMAPS* bmaps, var size_x, var size_y) // For internal use
{
	bmap_blit(_bmap,bmaps->bmap_topleft,vector(0,0,0),NULL);
	bmap_blit(_bmap,bmaps->bmap_topright,vector(size_x-bmap_width(bmaps->bmap_topright),0,0),NULL);
	bmap_blit(_bmap,bmaps->bmap_top,vector(bmap_width(bmaps->bmap_topleft),0,0),vector(size_x-bmap_width(bmaps->bmap_topleft)-bmap_width(bmaps->bmap_topright),bmap_height(bmaps->bmap_top),0));
	
	bmap_blit(_bmap,bmaps->bmap_bottomleft,vector(0,size_y-bmap_height(bmaps->bmap_bottomleft),0),NULL);
	bmap_blit(_bmap,bmaps->bmap_bottomright,vector(size_x-bmap_width(bmaps->bmap_bottomright),size_y-bmap_height(bmaps->bmap_bottomright),0),NULL);
	bmap_blit(_bmap,bmaps->bmap_left,vector(0,bmap_height(bmaps->bmap_top),0),vector(bmap_width(bmaps->bmap_left),size_y-bmap_height(bmaps->bmap_top)-bmap_height(bmaps->bmap_bottomleft),0));
	bmap_blit(_bmap,bmaps->bmap_right,vector(size_x-bmap_width(bmaps->bmap_right),bmap_height(bmaps->bmap_top),0),vector(bmap_width(bmaps->bmap_right),size_y-bmap_height(bmaps->bmap_top)-bmap_height(bmaps->bmap_bottomright),0));
	bmap_blit(_bmap,bmaps->bmap_bottom,vector(bmap_width(bmaps->bmap_bottomleft),size_y-bmap_height(bmaps->bmap_bottom),0),vector(size_x-bmap_width(bmaps->bmap_left)-bmap_width(bmaps->bmap_right),bmap_height(bmaps->bmap_bottom),0));
	
	bmap_blit(_bmap,bmaps->bmap_center,vector(bmap_width(bmaps->bmap_left),bmap_height(bmaps->bmap_top),0),vector(size_x-bmap_width(bmaps->bmap_left)-bmap_width(bmaps->bmap_right),size_y-bmap_height(bmaps->bmap_top)-bmap_height(bmaps->bmap_bottom),0));
	
}


int LBG_mouse_over_window (LBG_WINDOW* win)
{
	if(win) return((LBG_mouse_pos_x() > win->pos_x) && (LBG_mouse_pos_x() < win->pos_x + win->size_x) && (LBG_mouse_pos_y() > win->pos_y) && (LBG_mouse_pos_y() < win->pos_y + win->size_y));
	else return 1;
}

LBG_WINDOW* LBG_mouse_window ()
{
	LBG_LISTBOX* lst = LBG_LISTBOX_FIRST;
	while(lst)
	{
		if(lst->flags & LF_SHOW)
		if((lst->flags & LFi_RIGHTCLICK) || (lst->flags & LFi_COMBOBOX))
		if(LBG_mouse_over_object(lst))
		return lst;
		lst = lst->next;
	}
	
	LBG_WINDOW* winx = LBG_WINDOW_FIRST;
	LBG_WINDOW* win = winx;
	
	while(winx)
	{
		if(((winx->layer > win->layer) || ((win == LBG_WINDOW_FIRST) && (!LBG_mouse_over_window(win)))) && (LBG_mouse_over_window(winx))) win = winx;
		winx = winx->next;
	}
	if((win == LBG_WINDOW_FIRST) && (!LBG_mouse_over_window(win))) win = 0;
	
	return(win);
}

LBG_WINDOW* LBG_get_highest_window ()
{
	LBG_WINDOW* winx = LBG_WINDOW_FIRST;
	LBG_WINDOW* win = winx;
	
	while(winx)
	{
		if(winx->layer > win->layer) win = winx;
		winx = winx->next;
	}
	return(win);
}

LBG_WINDOW* LBG_get_highest_nsot_window () // not stay on top
{
	LBG_WINDOW* winx = LBG_WINDOW_FIRST;
	LBG_WINDOW* win = winx;
	
	while(winx)
	{
		if(((winx->layer > win->layer) && (!(winx->flags & WF_STAYONTOP))) || (win->flags & WF_STAYONTOP)) win = winx;
		winx = winx->next;
	}
	if (win->flags & WF_STAYONTOP) return 0;
	return(win);
}

var LBG_get_highest_window_layer ()
{
	LBG_WINDOW* win = LBG_get_highest_window ();
	if(win) return(win->layer);
	return(-1);
}


void LBG_update_window(LBG_WINDOW* win);
void LBG_update_window_layer(LBG_WINDOW* win);
void LBG_set_windows_with_layer_to (var oldlayer, var newlayer)
{
	LBG_WINDOW* win = LBG_WINDOW_FIRST;
	
	while(win)
	{
		if(win->layer == oldlayer)
		{
			win->layer = newlayer;
			LBG_update_window_layer(win);
		}
		win = win->next;
	}
}

LBG_WINDOW* LBG_get_window_by_layer(var layer)
{
	LBG_WINDOW* win = LBG_WINDOW_FIRST;
	
	while(win)
	{
		if(win->layer == layer)
		{
			return win;
		}
		win = win->next;
	}
	return 0;
}


void LBG_set_window_to_top (LBG_WINDOW* win);
void LBG_check_if_stayontop_windows_are_on_top ()
{
	LBG_WINDOW* win = LBG_WINDOW_FIRST;
	var lowest_stayontop = 999999;
	var highest_notstayontop = -1;
	LBG_WINDOW* winl;
	
	while(win)
	{
		if(win->flags & WF_STAYONTOP)
		{
			if(win->layer < lowest_stayontop) winl = win;
			lowest_stayontop = minv(lowest_stayontop,win->layer);
		}
		else
		{
			highest_notstayontop = maxv(highest_notstayontop,win->layer);
		}
		win = win->next;
	}
	if(lowest_stayontop < highest_notstayontop)
	{
		LBG_set_window_to_top(winl);
	}
}

void LBG_set_window_to_top_d (LBG_WINDOW* win);
void LBG_window_set_childs_to_top (LBG_WINDOW* win)
{
	LBG_WINDOW* winx = LBG_WINDOW_FIRST;
	while(winx)
	{
		if(winx->parent == win) LBG_set_window_to_top_d(winx);
		winx = winx->next;
	}
}

void LBG_set_window_to_top_c (LBG_WINDOW* win)
{
	var bak_layer = win->layer;
	win->layer = -1;
	var dest_layer = LBG_get_highest_window_layer ();
	
	var i;
	for(i=bak_layer+1;i<=dest_layer;i++) LBG_set_windows_with_layer_to(i,i-1);
	win->layer = dest_layer;
	if(win->layer < 0) win->layer = 0;
	LBG_update_window_layer(win);
	LBG_check_if_stayontop_windows_are_on_top();
}

void LBG_set_window_to_top_d (LBG_WINDOW* win)
{
	if (LBG_get_highest_window () == win) return;
	if ((!(win->flags & WF_STAYONTOP)) && (LBG_get_highest_nsot_window() == win)) return;
	LBG_set_window_to_top_c(win);
	LBG_window_set_childs_to_top(win);
}

void LBG_set_window_to_top (LBG_WINDOW* win)
{
	if (LBG_get_highest_window () == win) return;
	if ((!(win->flags & WF_STAYONTOP)) && (LBG_get_highest_nsot_window() == win)) return;
	if(win->parent)
	{
		LBG_set_window_to_top(win->parent);
	}
	else LBG_set_window_to_top_c(win);
	LBG_window_set_childs_to_top(win);
}



var LBG_window_calc_panel_layer (var wlayer)
{
	return(LBG_lowest_layer+LBG_winlayer+wlayer*LBG_layer_step);
}

var LBG_window_calc_text_layer (var wlayer)
{
	return(LBG_lowest_layer+LBG_winlayer+wlayer*LBG_layer_step+1);
}

var LBG_window_calc_content_layer (var wlayer)
{
	return(LBG_lowest_layer+LBG_winlayer+wlayer*LBG_layer_step+1);
}



void LBG_window_calc_hscroll_height (LBG_WINDOW* win)
{
	win->hscroll_height = 0;
	if(!(win->flags & WF_HSCROLLBAR)) return;
	
	LBG_HSCROLLBAR* hsb = LBG_HSCROLLBAR_FIRST;
	hsb = LBG_HSCROLLBAR_FIRST;
	while(hsb)
	{
		if(hsb->target == win)
		{
			win->hscroll_height = hsb->size_y;
			return;
		}
		hsb = hsb->next;
	}
}

void LBG_window_calc_vscroll_width (LBG_WINDOW* win)
{
	win->vscroll_width = 0;
	if(!(win->flags & WF_VSCROLLBAR)) return;
	
	LBG_VSCROLLBAR* vsb = LBG_VSCROLLBAR_FIRST;
	vsb = LBG_VSCROLLBAR_FIRST;
	while(vsb)
	{
		if(vsb->target == win)
		{
			win->vscroll_width = vsb->size_x;
			return;
		}
		vsb = vsb->next;
	}
}


void LBG_window_calc_csize (LBG_WINDOW* win)
{
	LBG_window_calc_hscroll_height(win);
	LBG_window_calc_vscroll_width(win);
	win->csize_x = win->size_x - LBG_window_leftborderwidth(win) - LBG_window_rightborderwidth(win) - win->vscroll_width;
	win->csize_y = win->size_y - LBG_window_titlebarheight(win) - LBG_window_bottomborderheight(win) - win->hscroll_height;
}






LBG_WINDOW* LBG_create_window (LBG_WINDOW* _parent, var pos_x, var pos_y, var size_x, var size_y, var tpos_x, var tpos_y,
STRING* caption, LBG_WBORDER_BMAPS* bbmaps, LBG_CBORDER_BMAPS* cbmaps, LBG_TBUTTON_BMAPS* tbmaps, var ctype, void* content,
long flags)
{
	LBG_WINDOW* win = malloc(sizeof(LBG_WINDOW));
	win->ssize = sizeof(LBG_WINDOW);
	win->stype = 1;
	
	if(flags & WF_EXTERNSTRING)
	{
		win->caption = caption;
	}
	else
	{
		win->caption = str_create("");
		str_cpy(win->caption,caption);
	}
	
	win->parent = _parent;
	win->layer = LBG_get_highest_window_layer()+1;
	win->flags = flags;
	
	
	win->text = txt_create(1,LBG_window_calc_text_layer(win->layer));
	ptr_remove((win->text->pstring)[0]);
	(win->text->pstring)[0] = win->caption;
	
	win->text->font = LBG_window_font;
	
	
	win->tpos_x = tpos_x;
	win->tpos_y = tpos_y;
	
	
	win->pos_x = pos_x;
	win->pos_y = pos_y;
	win->size_x = size_x;
	win->size_y = size_y;
	
	win->scale_x = 1;
	win->scale_y = 1;
	
	win->panel = pan_create("",LBG_window_calc_panel_layer(win->layer));
	if(bbmaps)
	{
		win->bbmaps.bmap_titlebar_left = bbmaps->bmap_titlebar_left;
		win->bbmaps.bmap_titlebar_middle = bbmaps->bmap_titlebar_middle;
		win->bbmaps.bmap_titlebar_right = bbmaps->bmap_titlebar_right;
		if(!win->bbmaps.bmap_titlebar_left) win->flags |= WFi_NOTITLEBAR;
		win->bbmaps.bmap_border_left = bbmaps->bmap_border_left;
		win->bbmaps.bmap_border_right = bbmaps->bmap_border_right;
		win->bbmaps.bmap_border_bottomleft = bbmaps->bmap_border_bottomleft;
		win->bbmaps.bmap_border_bottom = bbmaps->bmap_border_bottom;
		win->bbmaps.bmap_border_bottomright = bbmaps->bmap_border_bottomright;
		if(!win->bbmaps.bmap_border_left) win->flags |= WFi_NOBORDER;
	}
	else
	{
		win->flags |= WFi_NOTITLEBAR;
		win->flags |= WFi_NOBORDER;
	}
	
	if(cbmaps)
	{
		win->cbmaps.bmap_topleft = cbmaps->bmap_topleft;
		win->cbmaps.bmap_top = cbmaps->bmap_top;
		win->cbmaps.bmap_topright = cbmaps->bmap_topright;
		win->cbmaps.bmap_left = cbmaps->bmap_left;
		win->cbmaps.bmap_right = cbmaps->bmap_right;
		win->cbmaps.bmap_bottomleft = cbmaps->bmap_bottomleft;
		win->cbmaps.bmap_bottom = cbmaps->bmap_bottom;
		win->cbmaps.bmap_bottomright = cbmaps->bmap_bottomright;
		win->cbmaps.bmap_center = cbmaps->bmap_center;
	}
	
	if(tbmaps)
	{
		
		win->tbmaps.bmap_x_default = tbmaps.bmap_x_default;
		win->tbmaps.bmap_x_over = tbmaps.bmap_x_over;
		win->tbmaps.bmap_x_clicked = tbmaps.bmap_x_clicked;
		win->tbmaps.bmap_max_default = tbmaps.bmap_max_default;
		win->tbmaps.bmap_max_over = tbmaps.bmap_max_over;
		win->tbmaps.bmap_max_clicked = tbmaps.bmap_max_clicked;
		win->tbmaps.bmap_res_default = tbmaps.bmap_res_default;
		win->tbmaps.bmap_res_over = tbmaps.bmap_res_over;
		win->tbmaps.bmap_res_clicked = tbmaps.bmap_res_clicked;
	}
	
	
	win->panel->bmap = bmap_createblack(win->size_x,win->size_y,32);
	if(!(win->flags & WFi_NOTITLEBAR)) LBG_window_border_bitmap(win->panel->bmap,bbmaps,win->size_x,win->size_y);
	
	win->panel->pos_x = win->pos_x;
	win->panel->pos_y = win->pos_y;
	win->panel->size_x = win->size_x;
	win->panel->size_y = win->size_y;
	
	win->text->pos_x = win->pos_x + win->tpos_x;
	win->text->pos_y = win->pos_y + win->tpos_y;
	
	
	win->cpos_x = win->pos_x + LBG_window_leftborderwidth(win);
	win->cpos_y = win->pos_y + LBG_window_titlebarheight(win);
	
	LBG_window_calc_csize (win);
	
	
	win->ctype = ctype;
	
	if(win->ctype == 1)
	{
		win->content = pan_create("",LBG_window_calc_content_layer(win->layer));
		((PANEL*)(win->content))->bmap = bmap_createblack(win->csize_x,win->csize_y,32);
		LBG_window_content_bitmap(((PANEL*)(win->content))->bmap,cbmaps,win->csize_x,win->csize_y);
		((PANEL*)(win->content))->pos_x = win->cpos_x;
		((PANEL*)(win->content))->pos_y = win->cpos_y;
		((PANEL*)(win->content))->size_x = win->csize_x;
		((PANEL*)(win->content))->size_y = win->csize_y;
	}
	else if(win->ctype) win->content = content;
	
	
	
	win->minsize_x = size_x;
	win->minsize_y = size_y;
	win->maxsize_x = 0;
	win->maxsize_y = 0;
	
	
	win->bkx = win->pos_x;
	win->bky = win->pos_y;
	
	win->flags2 = 0;
	
	
	
	
	
	if (flags & WF_XBUTTON)
	{
		win->xbutton = LBG_create_button(win,win->size_x+win->xbutton_offx,win->xbutton_offy,0,0,"",LBG_bbmaps(win->tbmaps.bmap_x_default,win->tbmaps.bmap_x_over,win->tbmaps.bmap_x_clicked,win->tbmaps.bmap_x_default,win->tbmaps.bmap_x_over,win->tbmaps.bmap_x_default),0,BF_SHOW | BFi_TITLEBAR);
	}
	if (flags & WF_MAXBUTTON)
	{
		var _x = win->size_x+win->xbutton_offx;
		var _y = win->xbutton_offy;
		if(flags & WF_XBUTTON) _x -= bmap_width(win->tbmaps.bmap_max_default);
		win->maxbutton = LBG_create_button(win,_x,_y,0,0,"",LBG_bbmaps(win->tbmaps.bmap_max_default,win->tbmaps.bmap_max_over,win->tbmaps.bmap_max_clicked,win->tbmaps.bmap_max_default,win->tbmaps.bmap_max_over,win->tbmaps.bmap_max_default),0,BF_SHOW | BFi_TITLEBAR);
	}
	
	
	
	if(win->flags & WF_SHOW)
	{
		win->panel->flags |= SHOW;
		win->text->flags |= SHOW;
		if((win->ctype != 0) && win->content) ((PANEL*)(win->content))->flags |= SHOW;
	}
	
	
	win->next = NULL;
	if(LBG_WINDOW_FIRST == NULL)
	{
		LBG_WINDOW_FIRST = win;
		win->previous = NULL;
	}
	else
	{
		win->previous = LBG_object_last(LBG_WINDOW_FIRST);
		win->previous->next = win;
	}
	
	win->lastsize_x = win->size_x;
	win->lastsize_y = win->size_y;
	
	win->hscrollamount = 0;
	win->vscrollamount = 0;
	
	win->scroll_minsize_x = 0;
	win->scroll_minsize_y = 0;
	win->scroll_bordersize_x = 0;
	win->scroll_bordersize_y = 0;
	
	win->Destroy = 0;
	win->Close = 0;
	win->Maximize = 0;
	win->Restore = 0;
	win->Resize = 0;
	win->Resizing = 0;
	win->Move = 0;
	win->Moving = 0;
	
	
	LBG_update_window(win);
	
	LBG_window_calc_csize(win);
	LBG_check_if_stayontop_windows_are_on_top();
	
	return(win);
}


BOOL LBG_window_mouse_over_titlebar_button (LBG_WINDOW* win)
{
	BOOL ret = 0;
	if(win->flags & WF_XBUTTON) if(LBG_mouse_over_object(win->xbutton)) ret = 1;
	if(win->flags & WF_MAXBUTTON) if(LBG_mouse_over_object(win->maxbutton)) ret = 1;
	
	return (ret);
}

BOOL LBG_mouse_over_window_move (LBG_WINDOW* win)
{
	if(win) if(!(win->flags & WFi_NOTITLEBAR)) return ((LBG_mouse_pos_x() >= win->pos_x) && (LBG_mouse_pos_x() < win->pos_x + win->size_x) && (LBG_mouse_pos_y() >= win->pos_y) && (LBG_mouse_pos_y() < win->pos_y + LBG_window_titlebarheight(win)) && (LBG_mouse_window() == win) && (!LBG_window_mouse_over_titlebar_button(win)));
	return 0;
}

long LBG_mouse_over_window_border (LBG_WINDOW* win)
{
	if(LBG_mouse_window() != win) return (0);
	long ret = 0;
	// 1 = top
	// 2 = left
	// 4 = right
	// 8 = bottom
	if ((LBG_mouse_pos_x() >= win->pos_x) && (LBG_mouse_pos_x() < win->pos_x + LBG_window_leftborderwidth(win)) && (LBG_mouse_pos_y() >= win->pos_y + LBG_window_titlebarheight(win)) && (LBG_mouse_pos_y() < win->pos_y + win->size_y)) ret |= 2;
	if ((LBG_mouse_pos_x() >= win->pos_x + win->size_x - LBG_window_rightborderwidth(win)) && (LBG_mouse_pos_x() < win->pos_x + win->size_x) && (LBG_mouse_pos_y() >= win->pos_y + LBG_window_titlebarheight(win)) && (LBG_mouse_pos_y() < win->pos_y + win->size_y))  ret |= 4;
	if ((LBG_mouse_pos_x() >= win->pos_x) && (LBG_mouse_pos_x() < win->pos_x + win->size_x) && (LBG_mouse_pos_y() > win->pos_y + win->size_y - LBG_window_bottomborderheight(win)) && (LBG_mouse_pos_y() < win->pos_y + win->size_y))  ret |= 8;
	return (ret);
}

var LBG_window_minsx (LBG_WINDOW* win)
{
	return(maxv(LBG_window_leftborderwidth(win) + LBG_window_rightborderwidth(win),win->minsize_x));
}
var LBG_window_minsy (LBG_WINDOW* win)
{
	return(maxv(LBG_window_titlebarheight(win) + LBG_window_bottomborderheight(win),win->minsize_y));
}

var LBG_window_maxsx (LBG_WINDOW* win)
{
	if(win->maxsize_x) return(win->maxsize_x);
	return(4096);
}
var LBG_window_maxsy (LBG_WINDOW* win)
{
	if(win->maxsize_y) return(win->maxsize_y);
	return(4096);
}

long LBG_window_correct_size (LBG_WINDOW* win)
{
	BOOL ret = 0;
	if(win->size_x > LBG_window_maxsx(win)) {win->size_x = LBG_window_maxsx(win); ret = 1;}
	if(win->size_y > LBG_window_maxsy(win)) {win->size_y = LBG_window_maxsy(win); ret = 1;}
	
	if(win->size_x < LBG_window_minsx(win)) {win->size_x = LBG_window_minsx(win); ret = 1;}
	if(win->size_y < LBG_window_minsy(win)) {win->size_y = LBG_window_minsy(win); ret = 1;}
	
	return(ret);
}

void LBG_window_update_pos (LBG_WINDOW* win)
{
	LBG_window_correct_size(win);
	
	win->cpos_x = win->pos_x + LBG_window_leftborderwidth(win);
	win->cpos_y = win->pos_y + LBG_window_titlebarheight(win);
	
	LBG_window_calc_csize (win);
	
	win->panel->pos_x = win->pos_x;
	win->panel->pos_y = win->pos_y;
	win->panel->size_x = win->size_x;
	win->panel->size_y = win->size_y;
	
	win->text->pos_x = win->pos_x + win->tpos_x;
	win->text->pos_y = win->pos_y + win->tpos_y;
	
	if((win->ctype == 1) || (win->ctype == 2))
	{
		((PANEL*)(win->content))->pos_x = win->cpos_x;
		((PANEL*)(win->content))->pos_y = win->cpos_y;
		((PANEL*)(win->content))->size_x = win->csize_x;
		((PANEL*)(win->content))->size_y = win->csize_y;
	}
}

void LBG_update_window_layer (LBG_WINDOW* win)
{
	var x;
	x = LBG_window_calc_panel_layer(win->layer);
	if(win->panel->layer != x) layer_sort(win->panel,x);
	x = LBG_window_calc_text_layer(win->layer);
	if(win->text->layer != x) layer_sort(win->text,x);
	
	if(win->content && ((win->ctype == 1) || (win->ctype == 2)))
	{
		x = LBG_window_calc_content_layer(win->layer);
		if(((PANEL*)(win->content))->layer != x) layer_sort(win->content,LBG_window_calc_content_layer(win->layer));
	}
}


var LBG_window_get_ncsize_x (LBG_WINDOW* win)
{
	var x = win->scroll_minsize_x;
	LBG_BUTTON* but = LBG_BUTTON_FIRST;
	while(but)
	{
		if((but->parent == win) && (!((but->flags & BFi_TITLEBAR) || (but->flags & BFi_SCROLLBAR)))) x = maxv(x,but->pos_x + but->size_x);
		but = but->next;
	}
	LBG_PANEL* pan = LBG_PANEL_FIRST;
	while(pan)
	{
		if(pan->parent == win) x = maxv(x,pan->pos_x + pan->size_x);
		pan = pan->next;
	}
	LBG_TEXT* txt = LBG_TEXT_FIRST;
	while(txt)
	{
		if(txt->parent == win) x = maxv(x,txt->pos_x + txt->size_x);
		txt = txt->next;
	}
	LBG_CHECKBOX* cbx = LBG_CHECKBOX_FIRST;
	while(cbx)
	{
		if(cbx->parent == win) x = maxv(x,cbx->pos_x + cbx->size_x);
		cbx = cbx->next;
	}
	LBG_PROGRESSBAR* prg = LBG_PROGRESSBAR_FIRST;
	while(prg)
	{
		if(prg->parent == win) x = maxv(x,prg->pos_x + prg->size_x);
		prg = prg->next;
	}
	LBG_SLIDER* sli = LBG_SLIDER_FIRST;
	while(sli)
	{
		if(sli->parent == win) x = maxv(x,sli->pos_x + sli->size_x);
		sli = sli->next;
	}
	LBG_LISTBOX* lst = LBG_LISTBOX_FIRST;
	while(lst)
	{
		if(lst->parent == win) x = maxv(x,lst->pos_x + lst->size_x);
		lst = lst->next;
	}
	LBG_COMBOBOX* cbx = LBG_COMBOBOX_FIRST;
	while(cbx)
	{
		if(cbx->parent == win) x = maxv(x,cbx->pos_x + cbx->size_x);
		cbx = cbx->next;
	}
	LBG_DIGITS* dgts = LBG_DIGITS_FIRST;
	while(dgts)
	{
		if(dgts->parent == win) x = maxv(x,dgts->pos_x + dgts->size_x);
		dgts = dgts->next;
	}
	LBG_EDITBOX* ebx = LBG_EDITBOX_FIRST;
	while(ebx)
	{
		if(ebx->parent == win) x = maxv(x,ebx->pos_x + ebx->size_x);
		ebx = ebx->next;
	}
	return(x);
}

var LBG_window_get_hscrollmax (LBG_WINDOW* win)
{
	return(maxv(0,LBG_window_get_ncsize_x(win) + win->scroll_bordersize_x-win->csize_x));
}


var LBG_window_get_ncsize_y (LBG_WINDOW* win)
{
	var y = win->scroll_minsize_y;
	LBG_BUTTON* but = LBG_BUTTON_FIRST;
	while(but)
	{
		if((but->parent == win) && (!((but->flags & BFi_TITLEBAR) || (but->flags & BFi_SCROLLBAR)))) y = maxv(y,but->pos_y + but->size_y);
		but = but->next;
	}
	LBG_PANEL* pan = LBG_PANEL_FIRST;
	while(pan)
	{
		if(pan->parent == win) y = maxv(y,pan->pos_y + pan->size_y);
		pan = pan->next;
	}
	LBG_TEXT* txt = LBG_TEXT_FIRST;
	while(txt)
	{
		if(txt->parent == win) y = maxv(y,txt->pos_y + txt->size_y);
		txt = txt->next;
	}
	LBG_CHECKBOX* cbx = LBG_CHECKBOX_FIRST;
	while(cbx)
	{
		if(cbx->parent == win) y = maxv(y,cbx->pos_y + cbx->size_y);
		cbx = cbx->next;
	}
	LBG_PROGRESSBAR* prg = LBG_PROGRESSBAR_FIRST;
	while(prg)
	{
		if(prg->parent == win) y = maxv(y,prg->pos_y + prg->size_y);
		prg = prg->next;
	}
	LBG_SLIDER* sli = LBG_SLIDER_FIRST;
	while(sli)
	{
		if(sli->parent == win) y = maxv(y,sli->pos_y + sli->size_y);
		sli = sli->next;
	}
	LBG_LISTBOX* lst = LBG_LISTBOX_FIRST;
	while(lst)
	{
		if(lst->parent == win) y = maxv(y,lst->pos_y + lst->size_y);
		lst = lst->next;
	}
	LBG_COMBOBOX* cbx = LBG_COMBOBOX_FIRST;
	while(cbx)
	{
		if(cbx->parent == win) y = maxv(y,cbx->pos_y + cbx->size_y);
		cbx = cbx->next;
	}
	LBG_DIGITS* dgts = LBG_DIGITS_FIRST;
	while(dgts)
	{
		if(dgts->parent == win) y = maxv(y,dgts->pos_y + dgts->size_y);
		dgts = dgts->next;
	}
	LBG_EDITBOX* ebx = LBG_EDITBOX_FIRST;
	while(ebx)
	{
		if(ebx->parent == win) y = maxv(y,ebx->pos_y + ebx->size_y);
		ebx = ebx->next;
	}
	return(y);
}


var LBG_window_get_vscrollmax (LBG_WINDOW* win)
{
	return(maxv(0,LBG_window_get_ncsize_y(win) + win->scroll_bordersize_y-win->csize_y));
}


void LBG_window_execute (LBG_WINDOW* win, void* func)
{
	if(func != 0)
	{
		LBG_event_object = win;
		LBG_event_window = win;
		LBG_event = func;
		LBG_event();
	}
}

void LBG_update_window (LBG_WINDOW* win)
{
	LBG_window_update_pos (win);
	LBG_update_window_layer(win);
	
	ptr_remove(win->panel->bmap);
	
	
	LBG_HSCROLLBAR* hsb = LBG_HSCROLLBAR_FIRST;
	while(hsb)
	{
		if(hsb->target == win) hsb->scrollmax = LBG_window_get_hscrollmax(win);
		hsb = hsb->next;
	}
	LBG_VSCROLLBAR* vsb = LBG_VSCROLLBAR_FIRST;
	while(vsb)
	{
		if(vsb->target == win) vsb->scrollmax = LBG_window_get_vscrollmax(win);
		vsb = vsb->next;
	}
	
	
	
	
	LBG_window_calc_csize(win);
	if(win->flags & WF_AUTOHSCROLL)
	{
		if(win->flags & WF_HSCROLLBAR)
		{
			if (LBG_window_get_ncsize_x(win) + win->scroll_bordersize_x <= win->csize_x)
			{
				win->flags &= ~WF_HSCROLLBAR;
				win->hscrollamount = 0;
				LBG_HSCROLLBAR* hsb = LBG_HSCROLLBAR_FIRST;
				hsb = LBG_HSCROLLBAR_FIRST;
			}
		}
		else
		{
			if (LBG_window_get_ncsize_x(win) + win->scroll_bordersize_x > win->csize_x)
			{
				win->flags |= WF_HSCROLLBAR;
				LBG_HSCROLLBAR* hsb = LBG_HSCROLLBAR_FIRST;
				hsb = LBG_HSCROLLBAR_FIRST;
			}
		}
		LBG_window_update_pos(win);
	}
	if(win->flags & WF_AUTOVSCROLL)
	{
		if(win->flags & WF_VSCROLLBAR)
		{
			if (LBG_window_get_ncsize_y(win) + win->scroll_bordersize_y <= win->csize_y)
			{
				win->flags &= ~WF_VSCROLLBAR;
				win->vscrollamount = 0;
			}
		}
		else
		{
			if (LBG_window_get_ncsize_y(win) + win->scroll_bordersize_y > win->csize_y)
			{
				win->flags |= WF_VSCROLLBAR;
			}
		}
		LBG_window_update_pos(win);
	}
	LBG_window_calc_csize(win);
	
	
	win->panel->bmap = bmap_createblack(win->size_x,win->size_y,32);
	if(!(win->flags & WFi_NOTITLEBAR)) LBG_window_border_bitmap(win->panel->bmap,win->bbmaps,win->size_x,win->size_y);
	
	if(win->ctype == 1)
	{
		ptr_remove(((PANEL*)(win->content))->bmap);
		((PANEL*)(win->content))->bmap = bmap_createblack(win->csize_x,win->csize_y,32);
		LBG_window_content_bitmap(((PANEL*)(win->content))->bmap,win->cbmaps,win->csize_x,win->csize_y);
	}
}



void LBG_set_higher_windows_down (LBG_WINDOW* win)
{
	var n = LBG_get_highest_window_layer();
	var i;
	for(i=win->layer;i<n;i++) LBG_set_windows_with_layer_to(i+1,i);
}


LBG_WINDOW* LBG_destroy_window (LBG_WINDOW* win)
{
	LBG_window_execute(win,win->Destroy);
	
	LBG_set_higher_windows_down(win);
	
	if(!(win->flags & WF_EXTERNSTRING)) ptr_remove(win->caption);
	ptr_remove(win->text);
	ptr_remove(win->panel->bmap);
	ptr_remove(win->panel);
	
	if(win->ctype == 1)
	{
		ptr_remove(((PANEL*)(win->content))->bmap);
		ptr_remove((PANEL*)win->content);
	}
	
	if (win->flags & WF_XBUTTON)
	{
		LBG_destroy_button(win->xbutton);
	}
	if (win->flags & WF_MAXBUTTON)
	{
		LBG_destroy_button(win->maxbutton);
	}
	
	
	
	
	
	LBG_WINDOW* winx = LBG_WINDOW_FIRST;
	winx = LBG_WINDOW_FIRST;
	while(winx)
	{
		if(winx->parent == win)
		{
			if ((!(win->flags & WF_DONTDESTROYCHILDS)) && (!(winx->flags & WF_DONTDESTROY))) winx = LBG_destroy_window (winx);
			else
			{
				winx->parent = 0;
				LBG_update_window(winx);
			}
		}
		else winx = winx->next;
	}
	
	LBG_BUTTON* but = LBG_BUTTON_FIRST;
	but = LBG_BUTTON_FIRST;
	while(but)
	{
		if(but->parent == win)
		{
			if ((!(win->flags & WF_DONTDESTROYCHILDS)) && (!(but->flags & BF_DONTDESTROY))) but = LBG_destroy_button (but);
			else
			{
				but->parent = 0;
				LBG_update_button(but);
			}
		}
		else but = but->next;
	}
	
	LBG_PANEL* pan = LBG_PANEL_FIRST;
	pan = LBG_PANEL_FIRST;
	while(pan)
	{
		if(pan->parent == win)
		{
			if ((!(win->flags & WF_DONTDESTROYCHILDS)) && (!(pan->flags & PF_DONTDESTROY))) pan = LBG_destroy_panel (pan);
			else
			{
				pan->parent = 0;
				LBG_update_panel(pan);
			}
		}
		else pan = pan->next;
	}
	
	LBG_TEXT* txt = LBG_TEXT_FIRST;
	txt = LBG_TEXT_FIRST;
	while(txt)
	{
		if(txt->parent == win)
		{
			if ((!(win->flags & WF_DONTDESTROYCHILDS)) && (!(txt->flags & TF_DONTDESTROY))) txt = LBG_destroy_text (txt);
			else
			{
				txt->parent = 0;
				LBG_update_text(txt);
			}
		}
		else txt = txt->next;
	}
	
	LBG_CHECKBOX* cbx = LBG_CHECKBOX_FIRST;
	cbx = LBG_CHECKBOX_FIRST;
	while(cbx)
	{
		if(cbx->parent == win)
		{
			if ((!(win->flags & WF_DONTDESTROYCHILDS)) && (!(cbx->flags & CF_DONTDESTROY))) cbx = LBG_destroy_checkbox (cbx);
			else
			{
				cbx->parent = 0;
				LBG_update_checkbox(cbx);
			}
		}
		else cbx = cbx->next;
	}
	
	LBG_INFOBOX* ifo = LBG_INFOBOX_FIRST;
	ifo = LBG_INFOBOX_FIRST;
	while(ifo)
	{
		if(ifo->target == win)
		{
			ifo = LBG_destroy_infobox (ifo);
		}
		else ifo = ifo->next;
	}
	
	LBG_PROGRESSBAR* prg = LBG_PROGRESSBAR_FIRST;
	prg = LBG_PROGRESSBAR_FIRST;
	while(prg)
	{
		if(prg->parent == win)
		{
			if ((!(win->flags & WF_DONTDESTROYCHILDS)) && (!(prg->flags & PBF_DONTDESTROY))) prg = LBG_destroy_progressbar (prg);
			else
			{
				prg->parent = 0;
				LBG_update_progressbar(prg);
			}
		}
		else prg = prg->next;
	}
	
	LBG_HSCROLLBAR* hsb = LBG_HSCROLLBAR_FIRST;
	hsb = LBG_HSCROLLBAR_FIRST;
	while(hsb)
	{
		if(hsb->target == win)
		{
			hsb = LBG_destroy_hscrollbar (hsb);
		}
		else hsb = hsb->next;
	}
	LBG_VSCROLLBAR* vsb = LBG_VSCROLLBAR_FIRST;
	vsb = LBG_VSCROLLBAR_FIRST;
	while(vsb)
	{
		if(vsb->target == win)
		{
			vsb = LBG_destroy_vscrollbar (vsb);
		}
		else vsb = vsb->next;
	}
	
	LBG_SLIDER* sli = LBG_SLIDER_FIRST;
	sli = LBG_SLIDER_FIRST;
	while(sli)
	{
		if(sli->parent == win)
		{
			if ((!(win->flags & WF_DONTDESTROYCHILDS)) && (!(sli->flags & SF_DONTDESTROY))) sli = LBG_destroy_slider (sli);
			else
			{
				sli->parent = 0;
				LBG_update_slider(sli);
			}
		}
		else sli = sli->next;
	}
	
	LBG_LISTBOX* lst = LBG_LISTBOX_FIRST;
	lst = LBG_LISTBOX_FIRST;
	while(lst)
	{
		if(lst->parent == win)
		{
			if ((!(win->flags & WF_DONTDESTROYCHILDS)) && (!(lst->flags & LF_DONTDESTROY))) lst = LBG_destroy_listbox (lst);
			else
			{
				lst->parent = 0;
				LBG_update_listbox(lst);
			}
		}
		else lst = lst->next;
	}
	
	LBG_COMBOBOX* cbb = LBG_COMBOBOX_FIRST;
	cbb = LBG_COMBOBOX_FIRST;
	while(cbb)
	{
		if(cbb->parent == win)
		{
			if ((!(win->flags & WF_DONTDESTROYCHILDS)) && (!(cbb->flags & CF_DONTDESTROY))) cbb = LBG_destroy_combobox (cbb);
			else
			{
				cbb->parent = 0;
				LBG_update_combobox(cbb);
			}
		}
		else cbb = cbb->next;
	}
	
	LBG_DIGITS* dgts = LBG_DIGITS_FIRST;
	dgts = LBG_DIGITS_FIRST;
	while(dgts)
	{
		if(dgts->parent == win)
		{
			if ((!(win->flags & WF_DONTDESTROYCHILDS)) && (!(dgts->flags & DF_DONTDESTROY))) dgts = LBG_destroy_digits (dgts);
			else
			{
				dgts->parent = 0;
				LBG_update_digits(dgts);
			}
		}
		else dgts = dgts->next;
	}
	
	LBG_RIGHTCLICK* rcl = LBG_RIGHTCLICK_FIRST;
	rcl = LBG_RIGHTCLICK_FIRST;
	while(rcl)
	{
		if(rcl->target == win)
		{
			rcl = LBG_destroy_rightclick (rcl);
		}
		else rcl = rcl->next;
	}
	
	LBG_EDITBOX* ebx = LBG_EDITBOX_FIRST;
	ebx = LBG_EDITBOX_FIRST;
	while(ebx)
	{
		if(ebx->parent == win)
		{
			if ((!(win->flags & WF_DONTDESTROYCHILDS)) && (!(ebx->flags & EF_DONTDESTROY))) ebx = LBG_destroy_editbox (ebx);
			else
			{
				ebx->parent = 0;
				LBG_update_editbox(ebx);
			}
		}
		else ebx = ebx->next;
	}
	
	
	LBG_WINDOW* next = win->next;
	if(win->previous) win->previous->next = win->next;
	else LBG_WINDOW_FIRST = win->next;
	if(win->next) win->next->previous = win->previous;
	
	LBG_object_make_handles_invalid(win);
	free(win);
	
	
	return(next);
}



void LBG_update_textsize (LBG_WINDOW* win)
{
	win->text->size_x = win->size_x-win->tpos_x-1;
}

void LBG_maximize_window (LBG_WINDOW* win)
{
	win->bg_ver = win->pos_x;
	win->bg_hor = win->pos_y;
	win->mg_pos_x = win->size_x;
	win->mg_pos_y = win->size_y;
	
	win->flags |= WF_MAXIMIZED;
	
	win->pos_x = LBG_screenpos_x;
	win->pos_y = LBG_screenpos_y;
	
	win->size_x = LBG_screensize_x;
	win->size_y = LBG_screensize_y;
	
	((LBG_BUTTON*)(win->maxbutton))->bmap_default = win->tbmaps.bmap_res_default;
	((LBG_BUTTON*)(win->maxbutton))->bmap_over = win->tbmaps.bmap_res_over;
	((LBG_BUTTON*)(win->maxbutton))->bmap_clicked = win->tbmaps.bmap_res_clicked;
	((LBG_BUTTON*)(win->maxbutton))->bmap_active = win->tbmaps.bmap_res_default;
	((LBG_BUTTON*)(win->maxbutton))->bmap_overactive = win->tbmaps.bmap_res_over;
	((LBG_BUTTON*)(win->maxbutton))->bmap_disabled = win->tbmaps.bmap_res_default;
	
	LBG_update_window(win);
}

void LBG_restore_window (LBG_WINDOW* win)
{
	win->pos_x = win->bg_ver;
	win->pos_y = win->bg_hor;
	win->size_x = win->mg_pos_x;
	win->size_y = win->mg_pos_y;
	
	win->flags &= ~WF_MAXIMIZED;
	
	
	((LBG_BUTTON*)(win->maxbutton))->bmap_default = win->tbmaps.bmap_max_default;
	((LBG_BUTTON*)(win->maxbutton))->bmap_over = win->tbmaps.bmap_max_over;
	((LBG_BUTTON*)(win->maxbutton))->bmap_clicked = win->tbmaps.bmap_max_clicked;
	((LBG_BUTTON*)(win->maxbutton))->bmap_active = win->tbmaps.bmap_max_default;
	((LBG_BUTTON*)(win->maxbutton))->bmap_overactive = win->tbmaps.bmap_max_over;
	((LBG_BUTTON*)(win->maxbutton))->bmap_disabled = win->tbmaps.bmap_max_default;
	
	LBG_update_window(win);
}




LBG_WINDOW* LBG_manage_window (LBG_WINDOW* win)
{
	LBG_window_update_pos (win);
	LBG_update_window_layer(win);
	
	int ndbd = LBG_not_disabled_by_disableflag(win);
	
	if (!(win->flags & WF_DISABLED))
	{
		if((!(win->flags & WF_MAXIMIZED)) && (!(win->flags & WF_DONTMOVE)) && (ndbd))
		{
			if (!(key_pressed(280)))
			{
				win->flags2 &= ~WF2i_CLICK0;
				win->flags2 &= ~WF2i_CLICK1;
			}
			if ((ndbd) && LBG_mouse_over_window_move(win) && (((!(win->flags2 & WF2i_CLICK0)) && (!(win->flags2 & WF2i_CLICK1))) || ((!(win->flags2 & WF2i_CLICK0)) && ((win->flags2 & WF2i_CLICK1)))))
			{
				win->flags2 |= WF2i_OVER;
				if (key_pressed(280))
				{
					if(!((!(win->flags2 & WF2i_CLICK0)) && ((win->flags2 & WF2i_CLICK1))))
					{
						win->mg_pos_x = LBG_mouse_pos_x() - win->pos_x;
						win->mg_pos_y = LBG_mouse_pos_y() - win->pos_y;
						LBG_window_execute(win,win->Move);
					}
					
					win->flags2 &= ~WF2i_CLICK0;
					win->flags2 |= WF2i_CLICK1;
					
					LBG_window_execute(win,win->Moving);
				}
			}
			else
			{
				if(!(win->flags2 & WF2i_OVER))
				{
					win->flags2 &= ~WF2i_OVER;
				}
			}
			if ((!(win->flags2 & WF2i_CLICK0)) && ((win->flags2 & WF2i_CLICK1)))
			{
				win->pos_x = LBG_mouse_pos_x() - win->mg_pos_x;
				win->pos_y = LBG_mouse_pos_y() - win->mg_pos_y;
				
				LBG_window_update_pos(win);
			}
			if ((!(win->flags2 & WF2i_CLICK0)) && (!(win->flags2 & WF2i_CLICK1)) && (key_pressed(280)))
			{
				win->flags2 |= WF2i_CLICK0;
				win->flags2 &= ~WF2i_CLICK1;
			}
		}
		
		
		
		
		
		
		
		
		
		
		
		if ((win->flags & WF_RESIZEABLE) && (!(win->flags & WF_MAXIMIZED)) && (ndbd))
		{
			
			if (ndbd) switch(LBG_mouse_over_window_border(win))
			{
				case 1: case 8:
				if(!(win->flags & WF_LOCKSIZE_Y)) LBG_mouse_cursor = 3;
				break;
				
				case 2: case 4:
				if(!(win->flags & WF_LOCKSIZE_X)) LBG_mouse_cursor = 2;
				break;
				
				case 1|2: case 8|4:
				if(!((win->flags & WF_LOCKSIZE_X) && (win->flags & WF_LOCKSIZE_Y))) LBG_mouse_cursor = 4;
				break;
				
				case 1|4: case 8|2:
				if(!((win->flags & WF_LOCKSIZE_X) && (win->flags & WF_LOCKSIZE_Y))) LBG_mouse_cursor = 5;
				break;
			}
			
			if (!(key_pressed(280)))
			{
				win->flags2 &= ~WF2i_BRCLICK0;
				win->flags2 &= ~WF2i_BRCLICK1;
			}
			if ((ndbd) && (LBG_mouse_over_window_border(win) & 4) && (!(win->flags & WF_LOCKSIZE_X)) && (((!(win->flags2 & WF2i_BRCLICK0)) && (!(win->flags2 & WF2i_BRCLICK1))) || ((!(win->flags2 & WF2i_BRCLICK0)) && ((win->flags2 & WF2i_BRCLICK1)))))
			{
				win->flags2 |= WF2i_BROVER;
				if (key_pressed(280))
				{
					if(!((!(win->flags2 & WF2i_BRCLICK0)) && ((win->flags2 & WF2i_BRCLICK1))))
					{
						win->bg_hor = LBG_mouse_pos_x() - win->size_x;
						LBG_window_execute(win,win->Resize);
					}
					
					win->flags2 &= ~WF2i_BRCLICK0;
					win->flags2 |= WF2i_BRCLICK1;
					
					LBG_window_execute(win,win->Resizing);
				}
			}
			else
			{
				if(!(win->flags2 & WF2i_BROVER))
				{
					win->flags2 &= ~WF2i_BROVER;
				}
			}
			if ((!(win->flags2 & WF2i_BRCLICK0)) && ((win->flags2 & WF2i_BRCLICK1)))
			{
				win->size_x = LBG_mouse_pos_x() - win->bg_hor;
				if(LBG_mouse_cursor != 3) LBG_mouse_cursor = 2;
				else LBG_mouse_cursor = 4;
				
				if(win->lastsize_x != win->size_x) LBG_update_window(win);
			}
			if ((!(win->flags2 & WF2i_BRCLICK0)) && (!(win->flags2 & WF2i_BRCLICK1)) && (key_pressed(280)))
			{
				win->flags2 |= WF2i_BRCLICK0;
				win->flags2 &= ~WF2i_BRCLICK1;
			}
			
			///////////////////////////////
			
			if (!(key_pressed(280)))
			{
				win->flags2 &= ~WF2i_BBCLICK0;
				win->flags2 &= ~WF2i_BBCLICK1;
			}
			if ((ndbd) && (LBG_mouse_over_window_border(win) & 8) && (!(win->flags & WF_LOCKSIZE_Y)) && (((!(win->flags2 & WF2i_BBCLICK0)) && (!(win->flags2 & WF2i_BBCLICK1))) || ((!(win->flags2 & WF2i_BBCLICK0)) && ((win->flags2 & WF2i_BBCLICK1)))))
			{
				win->flags2 |= WF2i_BBOVER;
				if (key_pressed(280))
				{
					if(!((!(win->flags2 & WF2i_BBCLICK0)) && ((win->flags2 & WF2i_BBCLICK1))))
					{
						win->bg_ver = LBG_mouse_pos_y() - win->size_y;
						LBG_window_execute(win,win->Resize);
					}
					
					win->flags2 &= ~WF2i_BBCLICK0;
					win->flags2 |= WF2i_BBCLICK1;
					
					LBG_window_execute(win,win->Resizing);
				}
			}
			else
			{
				if(!(win->flags2 & WF2i_BBOVER))
				{
					win->flags2 &= ~WF2i_BBOVER;
				}
			}
			if ((!(win->flags2 & WF2i_BBCLICK0)) && ((win->flags2 & WF2i_BBCLICK1)))
			{
				win->size_y = LBG_mouse_pos_y() - win->bg_ver;
				if((LBG_mouse_cursor != 2) && (LBG_mouse_cursor != 4)) LBG_mouse_cursor = 3;
				else LBG_mouse_cursor = 4;
				
				if(win->lastsize_y != win->size_y) LBG_update_window(win);
			}
			if ((!(win->flags2 & WF2i_BBCLICK0)) && (!(win->flags2 & WF2i_BBCLICK1)) && (key_pressed(280)))
			{
				win->flags2 |= WF2i_BBCLICK0;
				win->flags2 &= ~WF2i_BBCLICK1;
			}
			
			///////////////////////////////
			
			if (!(key_pressed(280)))
			{
				win->flags2 &= ~WF2i_BLCLICK0;
				win->flags2 &= ~WF2i_BLCLICK1;
			}
			if ((ndbd) && (LBG_mouse_over_window_border(win) & 2) && (!(win->flags & WF_LOCKSIZE_X)) && (((!(win->flags2 & WF2i_BLCLICK0)) && (!(win->flags2 & WF2i_BLCLICK1))) || ((!(win->flags2 & WF2i_BLCLICK0)) && ((win->flags2 & WF2i_BLCLICK1)))))
			{
				win->flags2 |= WF2i_BLOVER;
				if (key_pressed(280))
				{
					if(!((!(win->flags2 & WF2i_BLCLICK0)) && ((win->flags2 & WF2i_BLCLICK1))))
					{
						win->bg_hor = LBG_mouse_pos_x() - win->pos_x;
						LBG_window_execute(win,win->Resize);
					}
					
					win->flags2 &= ~WF2i_BLCLICK0;
					win->flags2 |= WF2i_BLCLICK1;
					
					LBG_window_execute(win,win->Resizing);
				}
			}
			else
			{
				if(!(win->flags2 & WF2i_BLOVER))
				{
					win->flags2 &= ~WF2i_BLOVER;
				}
			}
			if ((!(win->flags2 & WF2i_BLCLICK0)) && ((win->flags2 & WF2i_BLCLICK1)))
			{
				win->size_x += (win->pos_x - (LBG_mouse_pos_x() - win->bg_hor));
				win->pos_x = LBG_mouse_pos_x() - win->bg_hor;
				if(LBG_mouse_cursor != 3) LBG_mouse_cursor = 2;
				else LBG_mouse_cursor = 5;
				
				if(LBG_window_correct_size(win)) win->pos_x = win->bkx;
				if(win->lastsize_x != win->size_x) LBG_update_window(win);
			}
			if ((!(win->flags2 & WF2i_BLCLICK0)) && (!(win->flags2 & WF2i_BLCLICK1)) && (key_pressed(280)))
			{
				win->flags2 |= WF2i_BLCLICK0;
				win->flags2 &= ~WF2i_BLCLICK1;
			}
		}
		
		
		
		
		
		
		
		
		
		
		if (!(key_pressed(280)))
		{
			win->flags2 &= ~WF2i_LYCLICK0;
			win->flags2 &= ~WF2i_LYCLICK1;
		}
		if ((ndbd) && (LBG_mouse_window() == win) && (((!(win->flags2 & WF2i_LYCLICK0)) && (!(win->flags2 & WF2i_LYCLICK1))) || ((!(win->flags2 & WF2i_LYCLICK0)) && ((win->flags2 & WF2i_LYCLICK1))))) // ((but_click == 0) || (but_click == 2))
		{
			win->flags2 |= WF2i_LYOVER;
			if (key_pressed(280))
			{
				win->flags2 &= ~WF2i_LYCLICK0;
				win->flags2 |= WF2i_LYCLICK1;
				
				if ((!(win->flags & WF_DONTSETTOTOP)) && (!(win->flags2 & WF2i_ASETTOTOP)))
				{
					LBG_set_window_to_top(win);
					win->flags2 |= WF2i_ASETTOTOP;
				}
			}
		}
		else
		{
			if(!(win->flags2 & WF2i_LYOVER))
			{
				win->flags2 &= ~WF2i_LYOVER;
			}
		}
		if ((!(win->flags2 & WF2i_LYCLICK0)) && (!(win->flags2 & WF2i_LYCLICK1)) && (key_pressed(280)))
		{
			win->flags2 |= WF2i_LYCLICK0;
			win->flags2 &= ~WF2i_LYCLICK1;
		}
		
		
		
	}
	
	if(!key_pressed(280)) win->flags2 &= ~WF2i_ASETTOTOP;
	
	
	LBG_update_textsize (win);
	
	
	
	win->bkx = win->pos_x;
	win->bky = win->pos_y;
	
	win->lastsize_x = win->size_x;
	win->lastsize_y = win->size_y;
	
	
	if(win->flags & WF_XBUTTON)
	{
		((LBG_BUTTON*)(win->xbutton))->pos_x = win->size_x+win->xbutton_offx;
		((LBG_BUTTON*)(win->xbutton))->pos_y = win->xbutton_offy;
		
		
		LBG_object_upate_pos(win->xbutton);
		
		if(((LBG_BUTTON*)(win->xbutton))->flags & BF_EVENT)
		{
			LBG_flags &= ~LBGUI_STOPACTION;
			LBG_window_execute(win,win->Close);
			if(!(LBG_flags & LBGUI_STOPACTION))
			{
				LBG_WINDOW* _w = win->next;
				LBG_destroy_window(win);
				return _w;
			}
		}
	}
	if(win->flags & WF_MAXBUTTON)
	{
		var _x = win->size_x+win->xbutton_offx;
		var _y = win->xbutton_offy;
		if(win->flags & WF_XBUTTON) _x -= bmap_width(win->tbmaps.bmap_max_default);
		((LBG_BUTTON*)(win->maxbutton))->pos_x = _x;
		((LBG_BUTTON*)(win->maxbutton))->pos_y = _y;
		
		LBG_object_upate_pos(win->maxbutton);
		
		if(((LBG_BUTTON*)(win->maxbutton))->flags & BF_EVENT)
		{
			LBG_flags &= ~LBGUI_STOPACTION;
			if (!(win->flags & WF_MAXIMIZED))
			{
				LBG_window_execute(win,win->Maximize);
				if(!(LBG_flags & LBGUI_STOPACTION)) LBG_maximize_window (win);
			}
			else
			{
				LBG_window_execute(win,win->Restore);
				if(!(LBG_flags & LBGUI_STOPACTION)) LBG_restore_window(win);
			}
		}
		
		
	}
	
	
	return win->next;
}








void LBG_wbmaps_destroy_2frames (LBG_WBORDER_BMAPS* bmaps) // for internal use
{
	wait(2);
	free(bmaps);
}

LBG_WBORDER_BMAPS* LBG_wbbmaps (BMAP* bmap_titlebar_left, BMAP* bmap_titlebar_middle, BMAP* bmap_titlebar_right,
BMAP* bmap_border_left, BMAP* bmap_border_right, BMAP* bmap_border_bottomleft, BMAP* bmap_border_bottom, BMAP* bmap_border_bottomright)
{
	LBG_WBORDER_BMAPS* bmaps = malloc(sizeof(LBG_WBORDER_BMAPS));
	bmaps->bmap_titlebar_left = bmap_titlebar_left;
	bmaps->bmap_titlebar_middle = bmap_titlebar_middle;
	bmaps->bmap_titlebar_right = bmap_titlebar_right;
	bmaps->bmap_border_left = bmap_border_left;
	bmaps->bmap_border_right = bmap_border_right;
	bmaps->bmap_border_bottomleft = bmap_border_bottomleft;
	bmaps->bmap_border_bottom = bmap_border_bottom;
	bmaps->bmap_border_bottomright = bmap_border_bottomright;
	LBG_wbmaps_destroy_2frames(bmaps);
	return(bmaps);
}


void LBG_wcbmaps_destroy_2frames (LBG_CBORDER_BMAPS* bmaps) // for internal use
{
	wait(2);
	free(bmaps);
}

LBG_CBORDER_BMAPS* LBG_wcbmaps (BMAP* bmap_topleft, BMAP* bmap_top, BMAP* bmap_topright, BMAP* bmap_left,
BMAP* bmap_right, BMAP* bmap_bottomleft, BMAP* bmap_bottom, BMAP* bmap_bottomright, BMAP* bmap_center)
{
	LBG_CBORDER_BMAPS* bmaps = malloc(sizeof(LBG_CBORDER_BMAPS));
	bmaps->bmap_topleft = bmap_topleft;
	bmaps->bmap_top = bmap_top;
	bmaps->bmap_topright = bmap_topright;
	bmaps->bmap_left = bmap_left;
	bmaps->bmap_right = bmap_right;
	bmaps->bmap_bottomleft = bmap_bottomleft;
	bmaps->bmap_bottom = bmap_bottom;
	bmaps->bmap_bottomright = bmap_bottomright;
	bmaps->bmap_center = bmap_center;
	LBG_wcbmaps_destroy_2frames(bmaps);
	return(bmaps);
}


void LBG_tbbmaps_destroy_2frames (LBG_TBUTTON_BMAPS* bmaps) // for internal use
{
	wait(2);
	free(bmaps);
}

LBG_TBUTTON_BMAPS* LBG_tbbmaps (BMAP* bmap_x_default, BMAP* bmap_x_over, BMAP* bmap_x_clicked,
BMAP* bmap_max_default, BMAP* bmap_max_over, BMAP* bmap_max_clicked,
BMAP* bmap_res_default, BMAP* bmap_res_over, BMAP* bmap_res_clicked)
{
	LBG_TBUTTON_BMAPS* bmaps = malloc(sizeof(LBG_TBUTTON_BMAPS));
	bmaps->bmap_x_default = bmap_x_default;
	bmaps->bmap_x_over = bmap_x_over;
	bmaps->bmap_x_clicked = bmap_x_clicked;
	
	bmaps->bmap_max_default = bmap_max_default;
	bmaps->bmap_max_over = bmap_max_over;
	bmaps->bmap_max_clicked = bmap_max_clicked;
	
	bmaps->bmap_res_default = bmap_res_default;
	bmaps->bmap_res_over = bmap_res_over;
	bmaps->bmap_res_clicked = bmap_res_clicked;
	LBG_tbbmaps_destroy_2frames(bmaps);
	return(bmaps);
}



int LBG_window_mouse_over_content (LBG_WINDOW* win)
{
	if (!win) return 1;
	return (LBG_mouse_pos_x() >= win->cpos_x) && (LBG_mouse_pos_x() < win->cpos_x + win->csize_x) && (LBG_mouse_pos_y() >= win->cpos_y) && (LBG_mouse_pos_y() < win->cpos_y + win->csize_y);
}



void LBG_window_add_xbutton (LBG_WINDOW* win)
{
	if(win->flags & WF_XBUTTON) return;
	win->flags |= WF_XBUTTON;
	win->xbutton = LBG_create_button(win,win->size_x+win->xbutton_offx,win->xbutton_offy,0,0,"",LBG_bbmaps(win->tbmaps.bmap_x_default,win->tbmaps.bmap_x_over,win->tbmaps.bmap_x_clicked,win->tbmaps.bmap_x_default,win->tbmaps.bmap_x_over,win->tbmaps.bmap_x_default),0,BF_SHOW | BFi_TITLEBAR);
}

void LBG_window_remove_xbutton (LBG_WINDOW* win)
{
	if(!(win->flags & WF_XBUTTON)) return;
	win->flags &= ~WF_XBUTTON;
	LBG_destroy_button(win->xbutton);
	win->xbutton = 0;
}


void LBG_window_add_maxbutton (LBG_WINDOW* win)
{
	if(win->flags & WF_MAXBUTTON) return;
	win->flags |= WF_MAXBUTTON;
	var _x = win->size_x+win->xbutton_offx;
	var _y = win->xbutton_offy;
	if(win->flags & WF_XBUTTON) _x -= bmap_width(win->tbmaps.bmap_max_default);
	win->maxbutton = LBG_create_button(win,_x,_y,0,0,"",LBG_bbmaps(win->tbmaps.bmap_max_default,win->tbmaps.bmap_max_over,win->tbmaps.bmap_max_clicked,win->tbmaps.bmap_max_default,win->tbmaps.bmap_max_over,win->tbmaps.bmap_max_default),0,BF_SHOW | BFi_TITLEBAR);
}

void LBG_window_remove_maxbutton (LBG_WINDOW* win)
{
	if(!(win->flags & WF_MAXBUTTON)) return;
	win->flags &= ~WF_MAXBUTTON;
	LBG_destroy_button(win->maxbutton);
	win->maxbutton = 0;
}

void LBG_resize_window (LBG_WINDOW* win, var size_x, var size_y)
{
	win->size_x = size_x;
	win->size_y = size_y;
	win->minsize_x = minv(win->minsize_x,win->size_x);
	win->minsize_y = minv(win->minsize_y,win->size_y);
	LBG_update_window(win);
}






LBG_WINDOW* LBG_search_disablegui ()
{
	LBG_WINDOW* win = LBG_WINDOW_FIRST;
	while(win)
	{
		if(win->flags & WF_DISABLEGUI) return win;
		win = win->next;
	}
	return 0;
}

int LBG_find_window_in_parents (LBG_WINDOW* obj,LBG_WINDOW* win)
{
	while(obj)
	{
		if(obj == win) return 1;
		obj = obj->parent;
	}
	return 0;
}



LBG_WINDOW* LBG_search_disableparent (LBG_WINDOW* obj)
{
	while((obj->stype != 1) && obj->parent) obj = obj->parent;
	LBG_WINDOW* win = LBG_WINDOW_FIRST;
	while(win)
	{
		if((win->flags & WF_DISABLEPARENT) && LBG_find_window_in_parents(win,obj)) return win;
		win = win->next;
	}
	return 0;
}
